<?PHP
// vim: set expandtab tabstop=4 shiftwidth=4: 
// +----------------------------------------------------------------------+
// | SAPID: XML Sapiens Engine Demonstrator                               |
// +----------------------------------------------------------------------+
// | Author:  Max Baryshnikov aka Mephius <mb@rg.by>	                  |
// | Copyright (c) 2004 Max Baryshnikov                                   |
// | http://sapid.sourceforge.net	                                      |
// +----------------------------------------------------------------------+
// | This source file is free software; you can redistribute it and/or    |
// | modify it under the terms of the GNU Lesser General Public           |
// | License as published by the Free Software Foundation; either         |
// | version 2.1 of the License, or (at your option) any later version.   |
// |                                                                      |
// | This source file is distributed in the hope that it will be useful,  |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of       |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU    |
// | Lesser General Public License for more details.                      |
// +----------------------------------------------------------------------+
// Release: 07.11.05 (dd/mm/yy)

/**
 * Sorting of an array (ascend)
 * 
 * @param string $a
 * @param string $b
 * @return boolean result
 */
if (!function_exists('cmp_indexasc')) {
   function cmp_indexasc($a, $b) { 
      global $sapi_obj; 
      $index = $sapi_obj->env["index"]; 
      return strcmp($a[$index], $b[$index]); 
   } 
} 
/**
 * Sorting of an array (descend)
 * 
 * @param string $b
 * @param string $a
 * @return boolean result
 */
if (!function_exists('cmp_indexdesc')) {
   function cmp_indexdesc($b, $a) { 
      global $sapi_obj; 
      $index = $sapi_obj->env["index"]; 
      return strcmp($a[$index], $b[$index]); 
   } 
}
/**
 * Sorting of an  array ([TITLE] asc)
 * 
 * @param string $a
 * @param string $b
 * @return boolean result
 */
if (!function_exists('cmp_nameasc')) {
	function cmp_nameasc($a, $b) {
		if($a["TITLE"] == $b["TITLE"]) return 0;
		return ($a["TITLE"] < $b["TITLE"]) ? -1 : 1;
	}
}
/**
 * Sorting of an array ([TITLE] desc)
 * 
 * @param string $a
 * @param string $b
 * @return boolean result
 */
if (!function_exists('cmp_namedesc')) {
	function cmp_namedesc($a, $b) {
		if($a["TITLE"] == $b["TITLE"]) return 0;
		return ($a["TITLE"] > $b["TITLE"]) ? -1 : 1;
	}
}
/**
 * Sorting of an array by date (asc)
 * 
 * @param string $a
 * @param string $b
 * @return boolean result
 */
if (!function_exists('cmp_datecasc')) {
	function cmp_datecasc($a, $b) {
		if($a["DATE"] == $b["DATE"]) return 0;
		return ($a["DATE"] < $b["DATE"]) ? -1 : 1;
	}
}
/**
 * Sorting of an array by date (desc)
 * 
 * @param string $a
 * @param string $b
 * @return boolean result
 */
if (!function_exists('cmp_datecdesc')) {
	function cmp_datecdesc($a, $b) {
		if($a["DATE"] == $b["DATE"]) return 0;
		return ($a["DATE"] > $b["DATE"]) ? -1 : 1;
	}
}
/**
 * Random sorting of an array 
 * 
 * @param string $a
 * @param string $b
 * @return boolean result
 */
if (!function_exists('cmp_random')) {
	function cmp_random($a, $b) {
		srand ((double) microtime() * 1000000);
		$randval = rand(-1,1);
		return $randval;
	}
}
/**
 * Sorting of an array by index (asc)
 * 
 * @param string $a
 * @param string $b
 * @return boolean result
 */
if (!function_exists('cmp_indexasc')) {
	function cmp_indexasc($a, $b) {
		global $sapi_obj;
		$index = $sapi_obj->env["index"];
		return strcmp($a[$index], $b[$index]);
	}
}
/**
 * Sorting of an array by index (desc)
 * 
 * @param string $a
 * @param string $b
 * @return boolean result
 */
if (!function_exists('cmp_indexasc')) {
	function cmp_indexdesc($a, $b) {
		global $sapi_obj;
		$index = $sapi_obj->env["index"];
		return strcmp($a[$index], $b[$index]);
	}
}

?>